/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pogr1_holec;

import java.util.*;
import java.awt.*;
/**
 * This class serves as an interface for a work with geometric algorithms.
 * @author milan
 */
public class GeometricAlgorithms {
//DATA
    ConvexHull hull2D;
    ConvexHull hull3D;
    ConvexHull hullDelaunayTriangulation;
    polygon MyPolygon;
    circle MyCircle;
    ArrayList<Point> Input2DPointsList;
    ArrayList<point> Input3DpointsList = new ArrayList<point>();
    ArrayList<line> LinesOfSceleton;
    ArrayList<line> LinesOfPolygon;
    ArrayList<triangle> TrianglesOfSurface;
    ArrayList<GO> outputListOfGO;

//METHODS
    public GeometricAlgorithms(ArrayList<Point> inpList) {
        Input2DPointsList = inpList;
    }

    public GeometricAlgorithms() {

    }

    public ArrayList<GO> getPolygon() {
        PolygonTriangulationPreprocessing(Input2DPointsList);
        MyPolygon = new polygon(Input3DpointsList);
        LinesOfPolygon = MyPolygon.getLines();
        //return LinesOfPolygon;
        outputListOfGO = ListOfGOprocessing(LinesOfPolygon);
        return outputListOfGO;
    }

    public ArrayList<GO> getTrapezoidalPolygon() {
        PolygonTriangulationPreprocessing(Input2DPointsList);
        MyPolygon = new polygon(Input3DpointsList);
        LinesOfPolygon = MyPolygon.getTrapezoidation();
        //return LinesOfPolygon;
        outputListOfGO = ListOfGOprocessing(LinesOfPolygon);
        return outputListOfGO;
    }

    public ArrayList<GO> getSmallestCircleOfSetOfPoints() {
        ArrayList<circle> outputCircles = new ArrayList<circle>();
        SmallestCirclePreprocessing(Input2DPointsList);
        outputCircles.add(BasicGeometry.FindSmallestCircleOfSetOfPoints(Input3DpointsList));
        //return outputCircles;
        outputListOfGO = ListOfGOprocessing(outputCircles);
        return outputListOfGO;
    }

    public ArrayList<line> getConvexHullOfSetOf3DPoints() {
        return LinesOfSceleton;
    }

    public ArrayList<GO> getConvexHullOfSetOf2DPoints() {
        ConvexHull2DPreprocessing(Input2DPointsList);
        hull2D = new ConvexHull(Input3DpointsList);
        LinesOfSceleton = ConvexHull2DPostprocessing(hull2D.getConvexHullSceleton());
        //return LinesOfSceleton;
        outputListOfGO = ListOfGOprocessing(LinesOfSceleton);
        return outputListOfGO;
    }

    public ArrayList<GO> getDelaunayTriangulationOfSetOf2DPoints() {
        double value = DelaunayTriangulationPreprocessing(Input2DPointsList);
        int disting = 0;
        hull2D = new ConvexHull(Input3DpointsList, disting);
        TrianglesOfSurface = DelaunayTriangulationPostprocessing(hull2D.getConvexHullSurface(), value);
        //return TrianglesOfSurface;
        outputListOfGO = ListOfGOprocessing(TrianglesOfSurface);
        return outputListOfGO;
    }

    public ArrayList<line> getVoronoiDiagramOfSetOf2DPoints() {
        return LinesOfSceleton;
    }

    public ArrayList<GO> getPolygonTriangulation() {
        PolygonTriangulationPreprocessing(Input2DPointsList);
        MyPolygon = new polygon(Input3DpointsList);
        TrianglesOfSurface = MyPolygon.getTriangulation();
        //return TrianglesOfSurface;
        outputListOfGO = ListOfGOprocessing(TrianglesOfSurface);
        return outputListOfGO;
    }

    private void ConvexHull3DPreprocessing(ArrayList<point> inpList) {

    }

    private void ConvexHull3DPostprocessing(ArrayList<point> inpList) {

    }

    private void ConvexHull2DPreprocessing(ArrayList<Point> inpList) {
        Point temp;
        for(Iterator i = inpList.iterator() ; i.hasNext(); ) {
            temp = (Point)i.next();
            point pU = new point(temp.x, temp.y, 1);
            point pL = new point(temp.x, temp.y, -1);
            Input3DpointsList.add(pU);
            Input3DpointsList.add(pL);
        }
    }

    private ArrayList<line> ConvexHull2DPostprocessing(ArrayList<line> inpList) {
        ArrayList<line> crossingLines = new ArrayList<line>();
        for(line l: inpList) {
            if((l.getZ1()<0 && l.getZ2()>0 || l.getZ2()<0 && l.getZ1()>0) && l.getX1() != l.getX2()) {
                crossingLines.add(l);
            }
        }
        return crossingLines;
    }

    private double DelaunayTriangulationPreprocessing(ArrayList<Point> inpList) {
        double control = 0;
        Point temp;
        for(Iterator i = inpList.iterator() ; i.hasNext(); ) {
            temp = (Point)i.next();
            point p = new point(temp.x, temp.y, temp.x*temp.x + temp.y*temp.y);
            Input3DpointsList.add(p);
            if(p.getZ() > control)
                control = p.getZ();
        }
        Input3DpointsList.add(new point(0, 0, 1000*control));
        return control+1;
    }

    private ArrayList<triangle> DelaunayTriangulationPostprocessing(ArrayList<triangle> inpList, double referenceDistance) {
        ArrayList<triangle> crossingTriangles = new ArrayList<triangle>();
        for(triangle t: inpList) {
            if(t.getZ1()>referenceDistance || t.getZ2()>referenceDistance || t.getZ3()>referenceDistance) {
                continue;
            }
            crossingTriangles.add(t);
        }
        return crossingTriangles;
    }

    private void PolygonTriangulationPreprocessing(ArrayList<Point> inpList) {
        Point temp;
        int size = inpList.size();
        ArrayList<point> tempList = new ArrayList<point>();
        point[] pointArray = new point[3*size];
        point initPoint, p;
        line l1, l2;
        int initIndex;

        for(int i=0; i<inpList.size(); i++) {
            temp = inpList.get(i);
            p = new point(temp.x, temp.y, 0);
            //Input3DpointsList.add(p);
            tempList.add(p);
            pointArray[i] = p;
            pointArray[size+i] = p;
            pointArray[2*size+i] = p;
        }

        initPoint = BasicGeometry.getSetOfPointsByY(tempList)[0];
        initIndex = tempList.indexOf(initPoint);

        l1 = new line(initPoint, pointArray[size+initIndex-1]);
        l2 = new line(initPoint, pointArray[size+initIndex+1]);
        double x1 = l1.vector[0];
        double x2 = l2.vector[0];
        if(l1.vector[0] > l2.vector[0]) {
                Input3DpointsList = tempList;
        }
        else {
            Input3DpointsList.add(tempList.get(0));
            for(int i=1; i<tempList.size(); i++) {
                Input3DpointsList.add(tempList.get(tempList.size()-i));
            }
        }
 
    }

    private void SmallestCirclePreprocessing(ArrayList<Point> inpList) {
        Point temp;
        for(Iterator i = inpList.iterator() ; i.hasNext(); ) {
            temp = (Point)i.next();
            point p = new point(temp.x, temp.y, 0);
            Input3DpointsList.add(p);
        }
    }

    private ArrayList<GO> ListOfGOprocessing(ArrayList list) {
        ArrayList<GO> ListOfGO = new ArrayList<GO>();
        for(Object object : list)
            ListOfGO.add((GO)object);
        return ListOfGO;
    }
}
