/*
 * POGR1_HolecView.java
 */

package pogr1_holec;

import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;

import java.util.*;
import java.lang.Math;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * The application's main frame.
 */
public class POGR1_HolecView extends FrameView {

    public POGR1_HolecView(SingleFrameApplication app) {
        super(app);

        initComponents();

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = POGR1_HolecApp.getApplication().getMainFrame();
            aboutBox = new POGR1_HolecAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        POGR1_HolecApp.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jPanelDisplay = new pogr1_holec.myJPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jSlider1 = new javax.swing.JSlider();
        buttonAddRandomPoints = new java.awt.Button();
        jSeparator6 = new javax.swing.JToolBar.Separator();
        jSeparator7 = new javax.swing.JToolBar.Separator();
        jToggleButtonSetOfPoints = new javax.swing.JToggleButton();
        jToggleButtonPolygon = new javax.swing.JToggleButton();
        jSeparator8 = new javax.swing.JToolBar.Separator();
        jToolBar2 = new javax.swing.JToolBar();
        checkboxAutomatic = new java.awt.Checkbox();
        buttonDisplayAlgorithm = new java.awt.Button();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jRadioButton1 = new javax.swing.JRadioButton();
        jSeparator4 = new javax.swing.JToolBar.Separator();
        jRadioButton2 = new javax.swing.JRadioButton();
        jSeparator5 = new javax.swing.JToolBar.Separator();
        jRadioButton3 = new javax.swing.JRadioButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        buttonReset = new java.awt.Button();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();
        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(pogr1_holec.POGR1_HolecApp.class).getContext().getResourceMap(POGR1_HolecView.class);
        mainPanel.setBackground(resourceMap.getColor("mainPanel.background")); // NOI18N
        mainPanel.setName("mainPanel"); // NOI18N

        jPanelDisplay.setBackground(resourceMap.getColor("jPanelDisplay.background"));
        jPanelDisplay.setName("jPanelDisplay"); // NOI18N
        jPanelDisplay.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPanelDisplayMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanelDisplayLayout = new javax.swing.GroupLayout(jPanelDisplay);
        jPanelDisplay.setLayout(jPanelDisplayLayout);
        jPanelDisplayLayout.setHorizontalGroup(
            jPanelDisplayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 813, Short.MAX_VALUE)
        );
        jPanelDisplayLayout.setVerticalGroup(
            jPanelDisplayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 75, Short.MAX_VALUE)
        );

        jPanel2.setBackground(resourceMap.getColor("jPanel3.background"));
        jPanel2.setName("jPanel2"); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 40, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 162, Short.MAX_VALUE)
        );

        jPanel3.setBackground(resourceMap.getColor("jPanel3.background")); // NOI18N
        jPanel3.setName("jPanel3"); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 37, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 162, Short.MAX_VALUE)
        );

        jPanel4.setBackground(resourceMap.getColor("jPanel3.background"));
        jPanel4.setName("jPanel4"); // NOI18N

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 813, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 40, Short.MAX_VALUE)
        );

        jPanel5.setBackground(resourceMap.getColor("jPanel3.background"));
        jPanel5.setName("jPanel5"); // NOI18N

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 813, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 35, Short.MAX_VALUE)
        );

        jToolBar1.setRollover(true);
        jToolBar1.setName("jToolBar1"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N
        jToolBar1.add(jLabel1);

        jTextField1.setColumns(3);
        jTextField1.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField1.setText(resourceMap.getString("jTextField1.text")); // NOI18N
        jTextField1.setName("jTextField1"); // NOI18N
        jToolBar1.add(jTextField1);

        jSeparator1.setName("jSeparator1"); // NOI18N
        jToolBar1.add(jSeparator1);

        jSlider1.setMajorTickSpacing(1);
        jSlider1.setValue(10);
        jSlider1.setName("jSlider1"); // NOI18N
        jToolBar1.add(jSlider1);

        buttonAddRandomPoints.setLabel(resourceMap.getString("buttonAddRandomPoints.label")); // NOI18N
        buttonAddRandomPoints.setName("buttonAddRandomPoints"); // NOI18N
        buttonAddRandomPoints.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonAddRandomPointsMouseClicked(evt);
            }
        });
        jToolBar1.add(buttonAddRandomPoints);

        jSeparator6.setName("jSeparator6"); // NOI18N
        jToolBar1.add(jSeparator6);

        jSeparator7.setName("jSeparator7"); // NOI18N
        jToolBar1.add(jSeparator7);

        buttonGroup2.add(jToggleButtonSetOfPoints);
        jToggleButtonSetOfPoints.setFont(resourceMap.getFont("jToggleButtonSetOfPoints.font")); // NOI18N
        jToggleButtonSetOfPoints.setText(resourceMap.getString("jToggleButtonSetOfPoints.text")); // NOI18N
        jToggleButtonSetOfPoints.setFocusable(false);
        jToggleButtonSetOfPoints.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButtonSetOfPoints.setName("jToggleButtonSetOfPoints"); // NOI18N
        jToggleButtonSetOfPoints.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButtonSetOfPoints.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jToggleButtonSetOfPointsMouseClicked(evt);
            }
        });
        jToolBar1.add(jToggleButtonSetOfPoints);

        buttonGroup2.add(jToggleButtonPolygon);
        jToggleButtonPolygon.setFont(resourceMap.getFont("jToggleButtonPolygon.font")); // NOI18N
        jToggleButtonPolygon.setSelected(true);
        jToggleButtonPolygon.setText(resourceMap.getString("jToggleButtonPolygon.text")); // NOI18N
        jToggleButtonPolygon.setFocusable(false);
        jToggleButtonPolygon.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButtonPolygon.setName("jToggleButtonPolygon"); // NOI18N
        jToggleButtonPolygon.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButtonPolygon.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jToggleButtonPolygonMouseClicked(evt);
            }
        });
        jToolBar1.add(jToggleButtonPolygon);

        jSeparator8.setName("jSeparator8"); // NOI18N
        jToolBar1.add(jSeparator8);

        jToolBar2.setRollover(true);
        jToolBar2.setName("jToolBar2"); // NOI18N

        checkboxAutomatic.setLabel(resourceMap.getString("checkboxAutomatic.label")); // NOI18N
        checkboxAutomatic.setName("checkboxAutomatic"); // NOI18N
        checkboxAutomatic.setState(true);
        jToolBar2.add(checkboxAutomatic);

        buttonDisplayAlgorithm.setFont(resourceMap.getFont("buttonDisplayAlgorithm.font")); // NOI18N
        buttonDisplayAlgorithm.setLabel(resourceMap.getString("buttonDisplayAlgorithm.label")); // NOI18N
        buttonDisplayAlgorithm.setName("buttonDisplayAlgorithm"); // NOI18N
        buttonDisplayAlgorithm.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonDisplayAlgorithmMouseClicked(evt);
            }
        });
        jToolBar2.add(buttonDisplayAlgorithm);

        jSeparator2.setName("jSeparator2"); // NOI18N
        jToolBar2.add(jSeparator2);

        buttonGroup1.add(jRadioButton1);
        jRadioButton1.setSelected(true);
        jRadioButton1.setText(resourceMap.getString("jRadioButton1.text")); // NOI18N
        jRadioButton1.setFocusable(false);
        jRadioButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRadioButton1.setName("jRadioButton1"); // NOI18N
        jRadioButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jRadioButton1);

        jSeparator4.setName("jSeparator4"); // NOI18N
        jToolBar2.add(jSeparator4);

        buttonGroup1.add(jRadioButton2);
        jRadioButton2.setText(resourceMap.getString("jRadioButton2.text")); // NOI18N
        jRadioButton2.setFocusable(false);
        jRadioButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRadioButton2.setName("jRadioButton2"); // NOI18N
        jRadioButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jRadioButton2);

        jSeparator5.setName("jSeparator5"); // NOI18N
        jToolBar2.add(jSeparator5);

        buttonGroup1.add(jRadioButton3);
        jRadioButton3.setText(resourceMap.getString("jRadioButton3.text")); // NOI18N
        jRadioButton3.setFocusable(false);
        jRadioButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRadioButton3.setName("jRadioButton3"); // NOI18N
        jRadioButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jRadioButton3);

        jSeparator3.setName("jSeparator3"); // NOI18N
        jToolBar2.add(jSeparator3);

        buttonReset.setFont(resourceMap.getFont("buttonReset.font")); // NOI18N
        buttonReset.setLabel(resourceMap.getString("buttonReset.label")); // NOI18N
        buttonReset.setName("buttonReset"); // NOI18N
        buttonReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonResetActionPerformed(evt);
            }
        });
        jToolBar2.add(buttonReset);

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelDisplay, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 902, Short.MAX_VALUE)
            .addComponent(jToolBar2, javax.swing.GroupLayout.DEFAULT_SIZE, 902, Short.MAX_VALUE)
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, mainPanelLayout.createSequentialGroup()
                        .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanelDisplay, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToolBar2, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(pogr1_holec.POGR1_HolecApp.class).getContext().getActionMap(POGR1_HolecView.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 902, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 716, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents

    private void jPanelDisplayMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanelDisplayMouseClicked
        POGR1_HolecApp.listOfInputPoints.add(evt.getPoint());
        setNumOfDisplayedPoints();
        mainPanel.repaint();
        if(checkboxAutomatic.getState())
            applyAlgorithm();
        mainPanel.repaint();
    }//GEN-LAST:event_jPanelDisplayMouseClicked

    private void buttonDisplayAlgorithmMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonDisplayAlgorithmMouseClicked
        applyAlgorithm();
        mainPanel.repaint();
    }//GEN-LAST:event_buttonDisplayAlgorithmMouseClicked

    private void buttonAddRandomPointsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonAddRandomPointsMouseClicked
        int NumOfPoints = jSlider1.getValue();
        int width = jPanelDisplay.getWidth()-2;
        int height = jPanelDisplay.getHeight()-2;
        
        for(int i=0; i<NumOfPoints; ++i) {
            Point p = new Point((int)java.lang.Math.round(width*java.lang.Math.random()), (int)java.lang.Math.round(height*java.lang.Math.random()));
            POGR1_HolecApp.listOfInputPoints.add(p);
        }
        setNumOfDisplayedPoints();
        if(checkboxAutomatic.getState())
            applyAlgorithm();
        mainPanel.repaint();
    }//GEN-LAST:event_buttonAddRandomPointsMouseClicked

    private void buttonResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonResetActionPerformed

        if(POGR1_HolecApp.listOfInputPoints != null)
            POGR1_HolecApp.listOfInputPoints.clear();
/*
        if(POGR1_HolecApp.listOfOutputLinesConvexHull != null)
            POGR1_HolecApp.listOfOutputLinesConvexHull.clear();
        if(POGR1_HolecApp.listOfOutputLinesPolygon != null)
            POGR1_HolecApp.listOfOutputLinesPolygon.clear();
        if(POGR1_HolecApp.listOfOutputTriangles != null)
            POGR1_HolecApp.listOfOutputTriangles.clear();
        if(POGR1_HolecApp.listOfOutputCircles != null)
            POGR1_HolecApp.listOfOutputCircles.clear();
 */
        for(ArrayList<GO> outpList : POGR1_HolecApp.listOfObjects)
            outpList.clear();
        POGR1_HolecApp.listOfObjects.clear();
        
        setNumOfDisplayedPoints();
        mainPanel.repaint();
    }//GEN-LAST:event_buttonResetActionPerformed

    private void jToggleButtonPolygonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jToggleButtonPolygonMouseClicked
        jRadioButton1.setText("DrawPolygon");
        jRadioButton2.setText("Triangulation");
        jRadioButton3.setText("Trapezoidation");
    }//GEN-LAST:event_jToggleButtonPolygonMouseClicked

    private void jToggleButtonSetOfPointsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jToggleButtonSetOfPointsMouseClicked
        jRadioButton1.setText("DelaunayTriangulation");
        jRadioButton2.setText("ConvexHull");
        jRadioButton3.setText("SmallestCircle");
    }//GEN-LAST:event_jToggleButtonSetOfPointsMouseClicked

    private void setNumOfDisplayedPoints() {
        Integer m = POGR1_HolecApp.listOfInputPoints.size();
        jTextField1.setText(m.toString());
    }

    private void applyAlgorithm() {
        POGR1_HolecApp.listOfObjects.clear();
        if(jToggleButtonSetOfPoints.isSelected())
            setOfPointsChooseAlgorithm();
        if(jToggleButtonPolygon.isSelected())
            PolygonChooseAlgorithm();
    };

    private void PolygonChooseAlgorithm() {
        if(POGR1_HolecApp.listOfInputPoints.size() >= 3) {
            GeometricAlgorithms Geometry = new GeometricAlgorithms(POGR1_HolecApp.listOfInputPoints);
            if(jRadioButton1.isSelected())
                //POGR1_HolecApp.listOfOutputLinesPolygon = Geometry.getPolygon();
                POGR1_HolecApp.listOfObjects.add(Geometry.getPolygon());
            if(jRadioButton2.isSelected())
                //POGR1_HolecApp.listOfOutputTriangles = Geometry.getPolygonTriangulation();
                POGR1_HolecApp.listOfObjects.add(Geometry.getPolygonTriangulation());
            if(jRadioButton3.isSelected())
                //POGR1_HolecApp.listOfOutputLinesPolygon = Geometry.getTrapezoidalPolygon();
                POGR1_HolecApp.listOfObjects.add(Geometry.getTrapezoidalPolygon());
        }
    }

    private void setOfPointsChooseAlgorithm() {
        if(POGR1_HolecApp.listOfInputPoints.size() >= 3) {
            GeometricAlgorithms Geometry = new GeometricAlgorithms(POGR1_HolecApp.listOfInputPoints);
            if(jRadioButton1.isSelected())
                //POGR1_HolecApp.listOfOutputTriangles = Geometry.getDelaunayTriangulationOfSetOf2DPoints();
                POGR1_HolecApp.listOfObjects.add(Geometry.getDelaunayTriangulationOfSetOf2DPoints());
            if(jRadioButton2.isSelected())
                //POGR1_HolecApp.listOfOutputLinesConvexHull = Geometry.getConvexHullOfSetOf2DPoints();
                POGR1_HolecApp.listOfObjects.add(Geometry.getConvexHullOfSetOf2DPoints());
            if(jRadioButton3.isSelected())
                //POGR1_HolecApp.listOfOutputCircles = Geometry.getSmallestCircleOfSetOfPoints();
                POGR1_HolecApp.listOfObjects.add(Geometry.getSmallestCircleOfSetOfPoints());
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Button buttonAddRandomPoints;
    private java.awt.Button buttonDisplayAlgorithm;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private java.awt.Button buttonReset;
    private java.awt.Checkbox checkboxAutomatic;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanelDisplay;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JToolBar.Separator jSeparator4;
    private javax.swing.JToolBar.Separator jSeparator5;
    private javax.swing.JToolBar.Separator jSeparator6;
    private javax.swing.JToolBar.Separator jSeparator7;
    private javax.swing.JToolBar.Separator jSeparator8;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JToggleButton jToggleButtonPolygon;
    private javax.swing.JToggleButton jToggleButtonSetOfPoints;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JToolBar jToolBar2;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;

    private JDialog aboutBox;
}

class myCanvas extends java.awt.Canvas {
    public ArrayList<java.awt.Point> listCan = new ArrayList<java.awt.Point>();
    @Override public void paint(Graphics g) {
        int width = 5;
        int height = 5;
        int l = POGR1_HolecApp.listOfInputPoints.size();
        if(l > 0) {
            for(int i=0; i < l; ++i) {
                java.awt.Point point = POGR1_HolecApp.listOfInputPoints.get(i);
                g.fillOval(point.x, point.y, width, height);
                g.drawOval(point.x, point.y, width, height);
            }
        }
    }
}

class myJPanel extends javax.swing.JPanel {
    public ArrayList<java.awt.Point> listCan = new ArrayList<java.awt.Point>();
    @Override public void setBackground(Color bg) {
        super.setBackground(bg);
    }
//    jPanel1.setBackground(resourceMap.getColor("jPanel1.background"));
    @Override public void paint(Graphics g) {
        int width = 4;
        int height = 4;

        for(Point node: POGR1_HolecApp.listOfInputPoints) {
                g.fillOval(node.x-width/2, node.y-height/2, width, height);
                g.drawOval(node.x-width/2, node.y-height/2, width, height);
        }

        for(ArrayList<GO> outputList : POGR1_HolecApp.listOfObjects) {
            for(GO object : outputList) {
                object.PaintMe(g);
            }
        }

/*
        if(POGR1_HolecApp.listOfOutputTriangles != null) {
            g.setColor(Color.black);
            for(triangle surface: POGR1_HolecApp.listOfOutputTriangles)
                surface.PaintMe(g);
        }
        if(POGR1_HolecApp.listOfOutputLinesPolygon != null) {
            g.setColor(Color.green);
            for(line scelet: POGR1_HolecApp.listOfOutputLinesPolygon)
                scelet.PaintMe(g);
        }
        if(POGR1_HolecApp.listOfOutputLinesConvexHull != null) {
            g.setColor(Color.red);
            for(line scelet: POGR1_HolecApp.listOfOutputLinesConvexHull)
                scelet.PaintMe(g);
        }
        if(POGR1_HolecApp.listOfOutputCircles != null) {
            g.setColor(Color.green);
            for(circle smallestCircle: POGR1_HolecApp.listOfOutputCircles)
                smallestCircle.PaintMe(g);
        }
 */
    }
}