/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pogr1_holec;

import java.util.*;
import java.awt.*;

/**
 * The represantation of geometric object 'polygon'
 * @author milan
 */
public class polygon extends GO {
//DATA
    private ArrayList<point> Inp3DpointsList;
    private ArrayList<triangle> TrianglesOfSurface;
    private ArrayList<line> LinesOfPolygon;
    private ArrayList<line> LinesOfTrapezoidalPolygon;
    public point center;
    public boolean[] ConvexPoints;
    public double[] ConvexPointsMeassure;
//METHODS
    public polygon(ArrayList<point> inpList) {
        Inp3DpointsList = inpList;
        LinesOfPolygon = CreatePolygon(Inp3DpointsList);
        ConvexPoints = new boolean[LinesOfPolygon.size()];
        ConvexPointsMeassure = new double[LinesOfPolygon.size()];
        setConvexPoints(LinesOfPolygon);
    }

    private ArrayList<line> CreatePolygon(ArrayList<point> inpList) {
        ArrayList<line> Polygonslines = new ArrayList<line>();
        for(int i = 0; i<inpList.size()-1; ++i) {
            Polygonslines.add(new line(inpList.get(i), inpList.get(i+1)));
        }
        Polygonslines.add(new line(inpList.get(inpList.size()-1), inpList.get(0)));
        return Polygonslines;
    }

    public ArrayList<line> getLines() {
        return LinesOfPolygon;
    }

    public ArrayList<triangle> getTriangulation() {
        ArrayList<line> TempPolygon = CreatePolygon(Inp3DpointsList);
        //checking polygon simplicity...no crossing lines
        ArrayList<triangle> temp = new ArrayList<triangle>();
        for(int i=0; i<TempPolygon.size(); i++) {
            for(int j=0; j<TempPolygon.size(); ++j) {
                if(j!=i) {
                    if(BasicGeometry.FindIntersectionPoint(TempPolygon.get(i), TempPolygon.get(j), 0.01)[3] == 1) {
                        return temp;
                    }
                }
            }
        }
        
        TrianglesOfSurface = TriangulatePolygon(TempPolygon);
        return TrianglesOfSurface;
    }

    public ArrayList<line> getTrapezoidation() {
        ArrayList<line> horizontalLines;
        horizontalLines = getHorizontalLines(LinesOfPolygon, BasicGeometry.getPointsByY(LinesOfPolygon));
        LinesOfTrapezoidalPolygon = LinesOfPolygon;
        for(line horizontal: horizontalLines)
            LinesOfTrapezoidalPolygon.add(horizontal);
        return LinesOfTrapezoidalPolygon;
    }

    private void setConvexPoints(ArrayList<line> listToDetermineConvexity) {
        double phi1, phi2, controlPhi, sum = 0;
        for(int i=0; i<listToDetermineConvexity.size()-1; ++i) {
            if(Math.asin(listToDetermineConvexity.get(i).vector[1]) < 0) {
                phi1 = 2*Math.PI - Math.acos(listToDetermineConvexity.get(i).vector[0]);
            }
            else {
                phi1 = Math.acos(listToDetermineConvexity.get(i).vector[0]);
            }
            if(Math.asin(listToDetermineConvexity.get(i+1).vector[1]) < 0) {
                phi2 = 2*Math.PI - Math.acos(listToDetermineConvexity.get(i+1).vector[0]);                
            }
            else {
                phi2 = Math.acos(listToDetermineConvexity.get(i+1).vector[0]);
            }
            controlPhi = phi2 - phi1;
            ConvexPointsMeassure[i] = Math.sin(controlPhi)*(listToDetermineConvexity.get(i+1).length + listToDetermineConvexity.get(i).length);
            sum += ConvexPointsMeassure[i];
            if(Math.sin(controlPhi) > 0)
                ConvexPoints[i] = true;
            else
                ConvexPoints[i] = false;
        }
        if(Math.asin(listToDetermineConvexity.get(listToDetermineConvexity.size()-1).vector[1]) < 0) {
            phi1 = 2*Math.PI - Math.acos(listToDetermineConvexity.get(listToDetermineConvexity.size()-1).vector[0]);
        }
        else {
            phi1 = Math.acos(listToDetermineConvexity.get(listToDetermineConvexity.size()-1).vector[0]);
        }
        if(Math.asin(listToDetermineConvexity.get(0).vector[1]) < 0) {
            phi2 = 2*Math.PI - Math.acos(listToDetermineConvexity.get(0).vector[0]);
        }
        else {
            phi2 = Math.acos(listToDetermineConvexity.get(0).vector[0]);
        }
        controlPhi = phi2 - phi1;
        ConvexPointsMeassure[listToDetermineConvexity.size()-1] = Math.sin(controlPhi);
        sum += ConvexPointsMeassure[listToDetermineConvexity.size()-1]*(listToDetermineConvexity.get(0).length + listToDetermineConvexity.get(listToDetermineConvexity.size()-1).length);
        sum = 0;
        if(Math.sin(controlPhi) > 0)
            ConvexPoints[listToDetermineConvexity.size()-1] = true;
        else
            ConvexPoints[listToDetermineConvexity.size()-1] = false;
        if(sum < 0) {
            for(int i=0; i<listToDetermineConvexity.size(); ++i)
                ConvexPoints[i] = !ConvexPoints[i];
        }
    }

    private ArrayList<triangle> TriangulatePolygon(ArrayList<line> polygon) {
        ArrayList<triangle> triangles = new ArrayList<triangle>();
        while(polygon.size()>3) {
            triangles = (ReducePolygonFromOneEar(polygon, triangles));
        }
        point p1 = new point(polygon.get(0).getX1(), polygon.get(0).getY1(), polygon.get(0).getZ1());
        point p2 = new point(polygon.get(1).getX1(), polygon.get(1).getY1(), polygon.get(1).getZ1());
        point p3 = new point(polygon.get(2).getX1(), polygon.get(2).getY1(), polygon.get(2).getZ1());
        triangles.add(new triangle(p1, p2, p3));

        return triangles;
    }

    private ArrayList<triangle> ReducePolygonFromOneEar(ArrayList<line> polygon, ArrayList<triangle> clippedTriangles) {
        triangle clippedEar = null;
        line substituingLine;
        point p1, p2, p3;
        int range = polygon.size()-1;
        for(int i=0; i<polygon.size()-1 && polygon.size()>3; ++i) {
            setConvexPoints(polygon);
            if(!ConvexPoints[i]) {
                continue;
            }
            p1 = new point(polygon.get(i).getX1(), polygon.get(i).getY1(), polygon.get(i).getZ1());
            p2 = new point(polygon.get(i+1).getX1(), polygon.get(i+1).getY1(), polygon.get(i+1).getZ1());
            p3 = new point(polygon.get(i+1).getX2(), polygon.get(i+1).getY2(), polygon.get(i+1).getZ2());
            substituingLine = new line(p1, p3);
            clippedEar = new triangle(p1, p2, p3);
            int control = 1;
            for(int j=0; j<polygon.size(); ++j) {
                if(j!=i && j!=i+1 && j!=i+2) {
                    if(clippedEar.PointInside(polygon.get(j).nodes[0])) {
                        control = 0;
                        break;
                    }
                }
            }
            if(control == 1) {
                clippedTriangles.add(clippedEar);
                polygon.set(i, substituingLine);
                polygon.remove(i+1);
                //i--;
            }
        }
        return clippedTriangles;
    }

    private boolean FindIntersection(line l1, line l2) {
        boolean control = false;
        double epsilon = 0.0001;
        double x = 0;
        double y = 0;

        if(l1.getGeneralEquation()[1] != 0 && l1.getGeneralEquation()[1] != 0 && (l1.getGeneralEquation()[0] != 0 || l1.getGeneralEquation()[0] != 0)) {
            x = (l1.getGeneralEquation()[2]-l2.getGeneralEquation()[2])/(l2.getGeneralEquation()[0]-l1.getGeneralEquation()[0]);
            y = l2.getGeneralEquation()[0]*x + l2.getGeneralEquation()[2];
        }
        else {
            if(l1.getGeneralEquation()[1] == 0) {
                x = - l1.getGeneralEquation()[2];
                y = l2.getGeneralEquation()[0]*x + l2.getGeneralEquation()[2];
            }
            if(l2.getGeneralEquation()[1] == 0) {
                x = - l2.getGeneralEquation()[2];
                y = l1.getGeneralEquation()[0]*x + l1.getGeneralEquation()[2];
            }
        }

        double y11 = l1.getY1();
        double v12 = l1.getY2();
        double y21 = l2.getY1();
        double y22 = l2.getY2();

        if( ((l1.getY1()>y+epsilon && l1.getY2()<y-epsilon) || (l1.getY2()>y+epsilon && l1.getY1()<y-epsilon)) && ((l2.getY1()>y+epsilon && l2.getY2()<y-epsilon) || (l2.getY2()>y+epsilon && l2.getY1()<y-epsilon)) )
            control = true;

        return control;
    }

    private ArrayList<line> getHorizontalLines(ArrayList<line> inpLines, point[] inpPoints) {
        ArrayList<line> crossingLines = new ArrayList<line>();
        line horizontalLine;
        point p1, p2;
        int controlL, controlR;
        double closestL, closestR, centr;
        double[] crossPoint;
        for(int i=0; i< inpPoints.length; ++i) {
            p1 = new point(-Double.MAX_VALUE, inpPoints[i].getY(), 0);
            p2 = new point(Double.MAX_VALUE, inpPoints[i].getY(), 0);
            horizontalLine = new line(p1, p2);
            controlL = controlR = 0;
            centr = inpPoints[i].getX();
            closestL = -Double.MAX_VALUE;
            closestR = Double.MAX_VALUE;
            for(int j=0; j<inpLines.size(); ++j) {
                if(inpPoints[i]==inpLines.get(j).nodes[0] || inpPoints[i]==inpLines.get(j).nodes[1])
                    continue;
                crossPoint = BasicGeometry.FindIntersectionPoint(horizontalLine, inpLines.get(j), 0.0);
                if(crossPoint[3]==1) {
                    if(crossPoint[0]>centr) {
                        controlR++;
                        if(closestR>crossPoint[0])
                            closestR = crossPoint[0];
                    }
                    else {
                        controlL++;
                        if(closestL<crossPoint[0])
                            closestL = crossPoint[0];
                    }
                }
            }
            if(controlL==0 && controlR==0)
                continue;
            if(controlL%2 != 0) {
                p1 = inpPoints[i];
                p2 = new point(closestL, inpPoints[i].getY(), 0);
                crossingLines.add(new line(p1, p2));
            }
            if(controlR%2 != 0) {
                p1 = inpPoints[i];
                p2 = new point(closestR, inpPoints[i].getY(), 0);
                crossingLines.add(new line(p1, p2));
            }
        }
        return crossingLines;
    }

    public void PaintMe(Graphics g) {

    };
}
