/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pogr1_holec;

import java.awt.*;


/**
 * The represantation of geometric object 'triangle'
 * @author milan
 */
public class triangle extends GO {
//Data
    private point[] nodes;
    private line[] edges;
    public point center;
    public point semiCenter;
//Methods
    public triangle() {

    }

    public triangle(point A, point B, point C) {
        nodes = new point[3];
        edges = new line[3];
        edges[0] = new line(A, B);
        edges[1] = new line(B, C);
        edges[2] = new line(C, A);
        setNodes(A, B, C);
        setCenter();
        setSemiCenter();
    }

    private void setNodes(point A, point B, point C) {
        nodes[0] = A;
        nodes[1] = B;
        nodes[2] = C;
    }

    private void setCenter() {
        center = new point((nodes[0].getX()+nodes[1].getX()+nodes[2].getX())/3, (nodes[0].getY()+nodes[1].getY()+nodes[2].getY())/3, (nodes[0].getZ()+nodes[1].getZ()+nodes[2].getZ())/3);
    }

    private void setSemiCenter() {
        point p1, p2;
        line l1, l2;
        double[] intersection = new double[4];
        double x, y, z, a, b, c, d;
        //x = x0 + a*t
        //y = y0 + b*t
        //z = z0 + c*t

        p1 = edges[0].center;
        a = edges[0].vector[1];
        b = -edges[0].vector[0];
        c = edges[0].vector[2];
        p2 = new point(p1.getX()+a*100, p1.getY()+b*100, p1.getZ()+c*100);
        l1 = new line(p1, p2);

        p1 = edges[1].center;
        a = edges[1].vector[1];
        b = -edges[1].vector[0];
        c = edges[1].vector[2];
        p2 = new point(p1.getX()+a, p1.getY()+b, p1.getZ()+c);
        l2 = new line(p1, p2);

        intersection = BasicGeometry.FindIntersectionPoint(l1, l2, 0.0);
        x = intersection[0];
        y = intersection[1];
        z = intersection[2];
        semiCenter = new point(x, y, z);
    }

    public double getX1() {
        return nodes[0].getX();
    }

    public double getY1() {
        return nodes[0].getY();
    }

    public double getZ1() {
        return nodes[0].getZ();
    }

    public double getX2() {
        return nodes[1].getX();
    }

    public double getY2() {
        return nodes[1].getY();
    }

    public double getZ2() {
        return nodes[1].getZ();
    }

    public double getX3() {
        return nodes[2].getX();
    }

    public double getY3() {
        return nodes[2].getY();
    }

    public double getZ3() {
        return nodes[2].getZ();
    }

    public void PaintMe(Graphics g) {
        int x1 = (int)java.lang.Math.round(nodes[0].getX());
        int y1 = (int)java.lang.Math.round(nodes[0].getY());
        int x2 = (int)java.lang.Math.round(nodes[1].getX());
        int y2 = (int)java.lang.Math.round(nodes[1].getY());
        int x3 = (int)java.lang.Math.round(nodes[2].getX());
        int y3 = (int)java.lang.Math.round(nodes[2].getY());

        g.drawLine(x1, y1, x2, y2);
        g.drawLine(x2, y2, x3, y3);
        g.drawLine(x3, y3, x1, y1);
    }

    public boolean PointInside(point p) {
        double checkValue, temp, q;
        double[] genEq;
        double control = 0;
        for(int i=0; i<3; i++) {
            genEq = edges[i].getGeneralEquation();
            q = genEq[2];
            temp = - genEq[0]*center.getX() - genEq[1]*center.getY();
            checkValue = - genEq[0]*p.getX() - genEq[1]*p.getY();
            if((temp-q)*(checkValue-q) >= 0)
                control++;
        }
        return control==3;
    }
}
